class CheckException(Exception):
    """
    Base exception used by checkplz classes. These exceptions are captured and held until all checks have been applied,
    then reraised by the class. This allows multiple exceptions to be reported without needing to resolve previous
    exceptions first.
    """


class FailedCheck(CheckException):
    """ Raised when a checked value fails to meet all expectations """


class BadEntry(CheckException):
    """ Raised when the values passed for checking contain a bad entry """


class CheckExceptionGroup(CheckException):
    """ Acts as a collector for multiple check exceptions """
