from datetime import datetime as dt, timedelta as td

import pytest

from checkplz.exceptions import FailedCheck
from checkplz.methods import past_or_present


def test_identical_return():
    """ Should return the exact value provided """
    o1 = dt.now()
    o2 = dt.now() - td(days=1)
    o3 = dt.now() - td(seconds=1)
    assert o1 == past_or_present(o1)
    assert o2 == past_or_present(o2)
    assert o3 == past_or_present(o3)


def test_now():
    """ Should succeed when provided with a present (now) time """
    assert past_or_present(dt.now())


def test_future():
    """ Should fail when provided with future time """
    with pytest.raises(FailedCheck):
        past_or_present(dt.now() + td(seconds=1))
